#ifndef EVAL_INPUT_H
#define EVAL_INPUT_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_input: public eval_op {
    tensor value_;
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_input () {}
    eval_input(const expression &expr);
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("Input") == proto_map.end());
        proto_map["Input"] = std::make_shared<eval_input>(); // where is expr?
    }
}; // class eval_input

#endif